package org.jeecg.modules.ctop.service.impl;

import cn.com.ctop.common.utils.Check;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import lombok.extern.slf4j.Slf4j;
import org.jeecg.common.constant.CtopAdConstant;
import org.jeecg.modules.ctop.entity.BindAccountLogin;
import org.jeecg.modules.ctop.mapper.BindAccountLoginMapper;
import org.jeecg.modules.ctop.service.IBindAccountLoginService;
import org.jeecg.modules.ctop.service.ICreateInternalService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Description: 账号绑定-登陆
 * @Author: jeecg-boot
 * @Date: 2019-07-31
 * @Version: V1.0
 */
@Slf4j
@Service
public class BindAccountLoginServiceImpl extends ServiceImpl<BindAccountLoginMapper, BindAccountLogin> implements IBindAccountLoginService {
    @Autowired
    private BindAccountLoginMapper bindAccountLoginMapper;
    @Autowired
    private ICreateInternalService createInternalService;
    @Override
    public boolean bindLogin(String advertiserId, String accountName, String password, String loginType, String userId) {
        Map<String, Object> requestMap = new HashMap<>();
        requestMap.put("advertiser_id", advertiserId);
        requestMap.put("account_name", accountName);
        requestMap.put("login_type", loginType);
        List<BindAccountLogin> bindAccounts = bindAccountLoginMapper.selectByMap(requestMap);
        if (!Check.isNull(bindAccounts)) {
            return false;
        }
        String accountId = "";
        //头条登录
        if (null != loginType && loginType.equals(CtopAdConstant.PLATFORM_TYPE_BYTEDANCE_PY)) {
            Map<String, Object> result = createInternalService.checkAccountPassword(accountName, password);
            Boolean checkSuccess = (Boolean) result.get("success");
            if (!checkSuccess) {
                return false;
            }
            accountId = (String) result.get("id");
        }
        BindAccountLogin bindAccountLogin = new BindAccountLogin();
        bindAccountLogin.setAdvertiserId(advertiserId);
        bindAccountLogin.setAccountName(accountName);
        bindAccountLogin.setPassword(password);
        bindAccountLogin.setAccountId(accountId);
        bindAccountLogin.setLoginType(loginType);
        bindAccountLogin.setUserId(userId);
        int i = bindAccountLoginMapper.insert(bindAccountLogin);
        if (i > 0) {
            log.info("登录账号绑定成功，广告主id:{}", bindAccountLogin.getAdvertiserId());
            return true;
        }
        return false;
    }

}
